#include <stdio.h>
#include <stdlib.h>

unsigned int
  n,
  map[50][50],
  score[50][50],
  loc[2500];

int comp(const void *a,const void *b) {
  const unsigned int
    *p=a,*q=b;
  unsigned int
    r1,c1,r2,c2;

  r1 = *p / n;
  c1 = *p % n;

  r2 = *q / n;
  c2 = *q % n;

  return map[r1][c1] - map[r2][c2];
}

int main(void) {
  unsigned int
    k,
    i,
    r,c,
    r2,c2,
    d;

  scanf("%d %d",&n,&k);

  for (r=0;r<n;r++)
    for (c=0;c<n;c++) {
      scanf("%d",&map[r][c]);
      score[r][c] = 0xffffffff;
    }

  for (i=0;i<n*n;i++)
    loc[i] = i;

  qsort(loc,n*n,sizeof(unsigned int),comp);

  for (i=0;i<n*n;i++) {
    r = loc[i] / n;
    c = loc[i] % n;
    if (map[r][c] == 1)
      score[r][c] = 0;
    else
      for (r2=0;r2<n;r2++)
        for (c2=0;c2<n;c2++)
          if (map[r2][c2] == map[r][c] - 1) {
            d = abs(r-r2) + abs(c-c2);
            if (score[r][c] > d + score[r2][c2] && score[r2][c2] != 0xffffffff)
              score[r][c] = d + score[r2][c2];
          }
  }

  d = 0xffffffff;
  for (r=0;r<n;r++)
    for (c=0;c<n;c++)
      if (map[r][c] == k && score[r][c] < d)
        d = score[r][c];

  printf("%d\n",d);
/*
  for (r=0;r<n;r++) {
    for (c=0;c<n;c++)
      printf("%d ",score[r][c]);
    putchar('\n');
  }
*/
  return 0;
}

