import java.util.*;

public class hopscotch_tbuzzelli {

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int n = in.nextInt();
		int k = in.nextInt();
		int[][] arr = new int[n][n];
		int[][] dist = new int[n][n];
		int oo = 1000000000;
		for (int[] a : dist) Arrays.fill(a, oo);
		ArrayDeque<Integer> q = new ArrayDeque<>();
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				arr[i][j] = in.nextInt() - 1;
				if (arr[i][j] == 0) {
					q.add(i);
					q.add(j);
					dist[i][j] = 0;
				}
			}
		}
		int ans = oo;
		while (!q.isEmpty()) {
			int x = q.poll();
			int y = q.poll();
			if (arr[x][y] == k - 1) {
				ans = Math.min(ans, dist[x][y]);
			}
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (arr[i][j] != arr[x][y] + 1) continue;
					if (dist[i][j] == oo) {
						q.add(i);
						q.add(j);
					}
					dist[i][j] = Math.min(dist[i][j], dist[x][y] + Math.abs(x - i) + Math.abs(y - j));
				}
			}
		}
		System.out.println(ans == oo ? -1 : ans);
	}
	
}
