#!/usr/bin/env python3
n, k = map(int, input().split())
grid = [[int(x) - 1 for x in input().split()] for _ in range(n)]
dist = [[float('inf') for _ in range(n)] for _ in range(n)]
pos = [[] for _ in range(k)]
for i in range(n):
    for j in range(n):
        pos[grid[i][j]].append((i, j))

for x, y in pos[0]:
    dist[x][y] = 0

for i in range(1, k):
    for old_x, old_y in pos[i - 1]:
        for cur_x, cur_y in pos[i]:
            dist[cur_x][cur_y] = min(dist[cur_x][cur_y], dist[old_x][old_y] + abs(cur_x - old_x) + abs(cur_y - old_y))

# bug here: taking min of empty set
ans = min(dist[x][y] for x, y in pos[k - 1])
if ans == float('inf'):
    ans = -1

print(ans)
