#!/usr/bin/env python3

import sys
n, K = [int(x) for x in sys.stdin.readline().split()]

INF = int(1e9)
g = []
dp = [[INF] * n for _ in range(n)]
for i in range(n):
  g.append([int(x) for x in sys.stdin.readline().split()])
  for j in range(n):
    if g[i][j] == 1: dp[i][j] = 0

ans = INF
for k in range(2, K + 1): # WA: starts at k=2, but if K=1, answer 0 is not considered
  for i in range(n):
    for j in range(n):
      if g[i][j] == k:
        for pi in range(n):
          for pj in range(n):
            if g[pi][pj] == k - 1 and dp[pi][pj] < INF:
              dp[i][j] = min(dp[i][j], dp[pi][pj] + abs(i - pi) + abs(j - pj))
        if k == K:
          ans = min(ans, dp[i][j])

print (-1 if ans == INF else ans)
